package validators

var (
	apiGroupValues = []string{"cloudapi", "cloudbroker", "system"}

	driverValues     = []string{"KVM_X86"}
	accessTypeValues = []string{"R", "RCX", "ARCXDU"}
	resTypesValues   = []string{"compute", "vins", "k8s", "openshift", "lb", "flipgroup"}
	protoValues      = []string{"tcp", "udp"}

	accountCUTypeValues = []string{"CU_M", "CU_C", "CU_D", "CU_DM", "CU_S", "CU_A", "CU_NO", "CU_I", "CU_NP"}

	bserviceModeValues = []string{"ABSOLUTE", "RELATIVE"}

	computeTopologyValues   = []string{"compute", "node"}
	computePolicyValues     = []string{"RECOMMENDED", "REQUIRED"}
	computeModeValues       = []string{"EQ", "EN", "ANY"}
	computeDiskTypeValues   = []string{"D", "B"}
	computeNetTypeValues    = []string{"EXTNET", "VINS"}
	computex86NetTypeValues = []string{"EXTNET", "VINS", "VFNIC", "DPDK"}
	computeOrderValues      = []string{"cdrom", "network", "hd"}
	computeDataDisksValues  = []string{"KEEP", "DETACH", "DESTROY"}
	computeDriverValues     = []string{"KVM_X86", "SVA_KVM_X86"}

	diskTypeValues = []string{"B", "T", "D"}

	flipgroupClientTypeValues = []string{"compute", "vins"}

	kvmNetTypeValues    = []string{"EXTNET", "VINS", "NONE"}
	kvmx86NetTypeValues = []string{"EXTNET", "VINS", "NONE", "VFNIC", "DPDK"}

	lbAlgorithmValues = []string{"roundrobin", "static-rr", "leastconn"}

	rgDefNetValues  = []string{"PRIVATE", "PUBLIC", "NONE"}
	rgNetTypeValues = []string{"PUBLIC", "PRIVATE"}

	vinsTypeValues = []string{"DHCP", "VIP", "EXCLUDED"}

	imageBootTypeValues     = []string{"uefi", "bios"}
	imageTypeValues         = []string{"windows", "linux", "unknown"}
	imageDriversValues      = []string{"KVM_X86"}
	imageArchitectureValues = []string{"X86_64"}

	sepFieldTypeValues = []string{"int", "str", "bool", "list", "dict"}

	networkPluginValues = []string{"flannel", "weavenet", "calico"}

	strictLooseValues = []string{"strict", "loose"}

	interfaceStateValues = []string{"on", "off"}

	actionValues = []string{"power_on", "shutdown", "force_shutdown", "reboot"}

	vmActionValues = []string{"stop", "move"}

	computeFeaturesValues = []string{"hugepages", "numa", "cpupin", "vfnic", "dpdk", "changemac"}

	networkInterfaceNamingValues = []string{"eth", "ens"}

	numaAffinityValues = []string{"none", "strict", "loose"}

	txModelValues = []string{"iothread", "timer", "selected by hypervisor"}

	ioEventFDValues = []string{"on", "off", "selected by hypervisor"}

	eventIDxValues = []string{"on", "off", "selected by hypervisor"}

	chipsetValues = []string{"i440fx", "Q35"}

	loaderTypeValues = []string{"linux", "windows", "unknown"}

	sepTypeValues = []string{"hitachi", "dorado", "tatlin", "shared", "local", "des"}

	languageValues = []string{"ru", "en"}
)

const (
	mtuMin = 1

	mtuMax = 9216
)
