package bservice

// Detailed info about BasicService
type RecordBasicService struct {
	// Account ID
	AccountID uint64 `json:"accountId"`

	// Account name
	AccountName string `json:"accountName"`

	// Base domain
	BaseDomain string `json:"baseDomain"`

	// List Computes
	Computes ListComputes `json:"computes"`

	// Number of cores
	CPUTotal uint64 `json:"cpuTotal"`

	// Created by
	CreatedBy string `json:"createdBy"`

	// Created time
	CreatedTime uint64 `json:"createdTime"`

	// Deleted by
	DeletedBy string `json:"deletedBy"`

	// Deleted time
	DeletedTime uint64 `json:"deletedTime"`

	// Amount of disk space used, GB
	DiskTotal uint64 `json:"diskTotal"`

	// Grid ID
	GID uint64 `json:"gid"`

	// List of Service Compute Groups
	Groups ListGroups `json:"groups"`

	// GUID
	GUID uint64 `json:"guid"`

	// ID
	ID uint64 `json:"id"`

	// Milestones
	Milestones uint64 `json:"milestones"`

	// Name
	Name string `json:"name"`

	// Parent service ID
	ParentSrvID uint64 `json:"parentSrvId"`

	// Parent service type
	ParentSrvType string `json:"parentSrvType"`

	// Total amount of RAM, MB
	RAMTotal uint64 `json:"ramTotal"`

	// Resource group ID
	RGID uint64 `json:"rgId"`

	// Resource group name
	RGName string `json:"rgName"`

	// List of snapshots
	Snapshots ListSnapshots `json:"snapshots"`

	// SSH key for connection
	SSHKey string `json:"sshKey"`

	// Username for SSH connection
	SSHUser string `json:"sshUser"`

	// status
	Status string `json:"status"`

	// TechStatus
	TechStatus string `json:"techStatus"`

	// Updated by
	UpdatedBy string `json:"updatedBy"`

	// Updated time
	UpdatedTime uint64 `json:"updatedTime"`

	// Whether user controlled
	UserManaged bool `json:"userManaged"`
}

// List of Groups
type ListGroups []ItemGroup

// Main information about Group
type ItemGroup struct {
	// Amount of computes
	Computes uint64 `json:"computes"`

	// Consistency
	Consistency bool `json:"consistency"`

	// Group ID
	ID uint64 `json:"id"`

	// Group name
	Name string `json:"name"`

	// Status
	Status string `json:"status"`

	// TechStatus
	TechStatus string `json:"techStatus"`
}

// List of Computes
type ListComputes []ItemCompute

// Main information about Compute
type ItemCompute struct {
	// Account ID
	AccountID uint64 `json:"accountId"`

	// Architecture
	Architecture string `json:"arch"`

	// Compute group ID
	CompGroupID uint64 `json:"compgroupId"`

	// Compute group name
	CompGroupName string `json:"compgroupName"`

	// compute group role
	CompGroupRole string `json:"compgroupRole"`

	// ID
	ID uint64 `json:"id"`

	// Name
	Name string `json:"name"`

	// Resource group ID
	RGID uint64 `json:"rgId"`

	// StackID
	StackID uint64 `json:"stackId"`

	// Status
	Status string `json:"status"`

	// Tech status
	TechStatus string `json:"techStatus"`
}

// List of Snapshot
type ListSnapshots []ItemSnapshot

// Main information about Snapshot
type ItemSnapshot struct {
	// GUID
	GUID string `json:"guid"`

	// Label
	Label string `json:"label"`

	// Timestamp
	Timestamp uint64 `json:"timestamp"`

	// Valid or not
	Valid bool `json:"valid"`
}

// List of BasicServices
type ListBasicServices struct {
	Data []ItemBasicService `json:"data"`

	EntryCount uint64 `json:"entryCount"`
}

// Main information about BasicService
type ItemBasicService struct {
	// Account ID
	AccountID uint64 `json:"accountId"`

	// Account name
	AccountName string `json:"accountName"`

	// Base domain
	BaseDomain string `json:"baseDomain"`

	// Created by
	CreatedBy string `json:"createdBy"`

	// Created time
	CreatedTime uint64 `json:"createdTime"`

	// Deleted by
	DeletedBy string `json:"deletedBy"`

	// Deleted time
	DeletedTime uint64 `json:"deletedTime"`

	// Grid ID
	GID uint64 `json:"gid"`

	// List of group IDs
	Groups []uint64 `json:"groups"`

	// GUID
	GUID uint64 `json:"guid"`

	// ID
	ID uint64 `json:"id"`

	// Name
	Name string `json:"name"`

	// Milestones
	Milestones uint64 `json:"milestones"`

	// Parent service ID
	ParentSrvID uint64 `json:"parentSrvId"`

	// Parent service type
	ParentSrvType string `json:"parentSrvType"`

	// Resource group ID
	RGID uint64 `json:"rgId"`

	// Resource group name
	RGName string `json:"rgName"`

	// List of snapshots
	Snapshots ListSnapshots `json:"snapshots"`

	// SSH key for connection
	SSHKey string `json:"sshKey"`

	// SSH user
	SSHUser string `json:"sshUser"`

	// Status
	Status string `json:"status"`

	// TechStatus
	TechStatus string `json:"techStatus"`

	// Updated by
	UpdatedBy string `json:"updatedBy"`

	// Updated time
	UpdatedTime uint64 `json:"updatedTime"`

	// User Managed or not
	UserManaged bool `json:"userManaged"`
}
